From d83dfe15de4f246aa019981403bc4f41557e9175 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Mar 25 2021 05:11:39 +0000
Subject: [PATCH 2179/2232] Merge pull request #761 from dtolnay/vecdoc


No-inline documentation of CxxVector within cxx::vector module
---

diff --git a/src/cxx_vector.rs b/src/cxx_vector.rs
index c9c7d78..a8422d4 100644
--- a/src/cxx_vector.rs
+++ b/src/cxx_vector.rs
@@ -13,9 +13,6 @@ use core::pin::Pin;
 use core::ptr;
 use core::slice;
 
-#[doc(inline)]
-pub use crate::Vector;
-
 /// Binding to C++ `std::vector<T, std::allocator<T>>`.
 ///
 /// # Invariants
diff --git a/src/lib.rs b/src/lib.rs
index fb00d94..acb28fb 100644
--- a/src/lib.rs
+++ b/src/lib.rs
@@ -400,6 +400,7 @@ extern crate std;
 #[macro_use]
 mod macros;
 
+mod cxx_vector;
 mod exception;
 mod extern_type;
 mod fmt;
@@ -418,17 +419,15 @@ mod symbols;
 mod type_id;
 mod unique_ptr;
 mod unwind;
-#[path = "cxx_vector.rs"]
 pub mod vector;
 mod weak_ptr;
 
+pub use crate::cxx_vector::CxxVector;
 pub use crate::exception::Exception;
 pub use crate::extern_type::{kind, ExternType};
 pub use crate::shared_ptr::SharedPtr;
 pub use crate::string::CxxString;
 pub use crate::unique_ptr::UniquePtr;
-#[doc(inline)]
-pub use crate::vector::CxxVector;
 pub use crate::weak_ptr::WeakPtr;
 pub use cxxbridge_macro::bridge;
 
@@ -449,6 +448,7 @@ pub type Vector<T> = CxxVector<T>;
 // Not public API.
 #[doc(hidden)]
 pub mod private {
+    pub use crate::cxx_vector::VectorElement;
     pub use crate::extern_type::{verify_extern_kind, verify_extern_type};
     pub use crate::function::FatFunction;
     pub use crate::opaque::Opaque;
@@ -462,7 +462,6 @@ pub mod private {
     pub use crate::string::StackString;
     pub use crate::unique_ptr::UniquePtrTarget;
     pub use crate::unwind::catch_unwind;
-    pub use crate::vector::VectorElement;
     pub use crate::weak_ptr::WeakPtrTarget;
     pub use cxxbridge_macro::type_id;
 }
diff --git a/src/unique_ptr.rs b/src/unique_ptr.rs
index 2d16a45..9133783 100644
--- a/src/unique_ptr.rs
+++ b/src/unique_ptr.rs
@@ -1,7 +1,7 @@
+use crate::cxx_vector::{CxxVector, VectorElement};
 use crate::fmt::display;
 use crate::kind::Trivial;
 use crate::string::CxxString;
-use crate::vector::{CxxVector, VectorElement};
 use crate::ExternType;
 use core::ffi::c_void;
 use core::fmt::{self, Debug, Display};
diff --git a/src/vector.rs b/src/vector.rs
new file mode 100644
index 0000000..6963c3d
--- /dev/null
+++ b/src/vector.rs
@@ -0,0 +1,8 @@
+//! Less used details of `CxxVector` are exposed in this module. `CxxVector`
+//! itself is exposed at the crate root.
+
+pub use crate::cxx_vector::{Iter, IterMut};
+#[doc(inline)]
+pub use crate::Vector;
+#[doc(no_inline)]
+pub use cxx::CxxVector;

